-- which.lua
--    R}ĥꂽfBNg𒲂ׂ

function nyaos.command.which(cmd)
    local path='.;' .. os.getenv('PATH')

    --- ꍇ́APATH ̈ꗗ\邾 ---
    if not cmd or cmd:len()==0 then
        for path1 in path:gmatch('[^;]+') do
            print(path1)
        end
        return
    end

    local cmdl=cmd:lower()

    --- GCAX ---
    local a=nyaos.alias[ cmdl ]
    if a then
        print('aliased as '..a)
    end
    --- ֐ ---
    local f=nyaos.functions[ cmdl ]
    if f then
        print('defined as function')
    end

    local variation={
        [ cmdl ] = true ,
        [ cmdl .. '.exe' ] = true ,
        [ cmdl .. '.cmd' ] = true ,
        [ cmdl .. '.bat' ] = true ,
        [ cmdl .. '.com' ] = true
    }
    for key,val in pairs(nyaos.suffix) do
        variation[ cmdl .. '.' .. key:lower() ] = true
    end

    for path1 in path:gmatch('[^;]+') do
        for fname in nyaos.dir(path1) do
            if variation[ fname:lower() ] then
                print( path1 .. '\\' .. fname )
            end
        end
    end
end

-- u-tvIvVtŋNꂽF
for i,e in pairs(nyaos.argv) do
    if e == '-t' then
        -- ls ɃJ[IvVt --
        nyaos.alias.ls = (nyaos.alias.ls or 'ls')..' --color -x'

        if os.getenv('VIMSHELL') == '1' then
            nyaos.option.ls_colors='fi=37:di=32:sy=31:ro=34:hi=33:ex=35:ec=0'
            nyaos.option.prompt='$e[31m[$w]$_$$ $e[37m'
            nyaos.option.term_clear = ''
            nyaos.option.term_cursor_on = ''

            function nyaos.command.complete_test(arg)
                local list=nyaos.default_complete(arg,1)
                for i=1,#list do
                    print(list[i][2])
                end
            end
        else
            nyaos.option.ls_colors='fi=30:di=32:sy=31:ro=34:hi=33:ex=35:ec=0'
            nyaos.option.prompt='$e[31m[$w]$_$$ $e[30m'
        end
    end
end
